import { Group, Matrix3, Matrix4, Object3D, Vector3 } from "three";
import { ObjectSnapMode } from "../../Editor/ObjectSnapMode";
import { Box3Ext } from "../../Geometry/Box";
import { RenderType } from "../../GraphicsSystem/RenderType";
import { CADFiler } from "../CADFiler";
import { ObjectId } from "../ObjectId";
import { PhysicalMaterialRecord } from "../PhysicalMaterialRecord";
import { Entity } from "./Entity";
/**
 * 外部引用的实体,比如glTF
 */
export declare class EntityFbx extends Entity {
    private _url?;
    OnlyRenderType: boolean;
    private _Size;
    private _ScaleSize;
    private _Center;
    private _OverWriteMaterial;
    constructor(_url?: string);
    get IsVisible(): boolean;
    get Url(): string;
    set Url(url: string);
    get CurSize(): Vector3;
    get ScaleSize(): Vector3;
    set ScaleSize(size: Vector3);
    get Scale(): Vector3;
    get BoundingBox(): Box3Ext;
    get BoundingBoxInOCS(): Box3Ext;
    get OverWriteMaterial(): Map<number, ObjectId<PhysicalMaterialRecord>>;
    SetMaterialAtSlot(mtl: ObjectId<PhysicalMaterialRecord>, slotIndex: number): void;
    newObject: Group;
    LoadFBXModelFromArrayBuffer(fbxArray: ArrayBuffer): string;
    CloneDrawObject(from: this): void;
    ApplyScaleMatrix(m: Matrix4): this;
    InitDrawObject(renderType?: RenderType): Object3D;
    UpdateDrawObject(type: RenderType, obj: Object3D): void;
    UpdateDrawObjectMaterial(renderType: RenderType, obj: Object3D): void;
    GetObjectSnapPoints(snapMode: ObjectSnapMode, pickPoint: Vector3, lastPoint: Vector3, viewXform: Matrix3): Vector3[];
    MoveGripPoints(indexList: Array<number>, vec: Vector3): void;
    protected _ReadFile(file: CADFiler): void;
    WriteFile(file: CADFiler): void;
}
//# sourceMappingURL=EntityFbx.d.ts.map